# KyuII

KyuII is based on the [id Tech 2](https://en.wikipedia.org/wiki/Id_Tech#id_Tech_2) game engine
utilized by [Quake II](https://en.wikipedia.org/wiki/Quake_II) and its derivatives.

The intent is to add support for modern game features and new gameplay mechanics while retaining
backwards-compatibility with Quake II and interoperability with existing source ports to the
greatest extent possible.

Right now, the project is essentially stock Quake II as released under the GPL by id Software just
spruced up with the bare minimum changes required to compile it on a modern system. I do not
suggest anyone use this project at this time.

## Licensing & Credits

The majority of the project still derives from the [GPL-2.0](https://opensource.org/licenses/gpl-2.0.php)
Quake II source release by id Software and so the project as a whole shares that license. As
individual components are rewritten and replaced, however, all new source created wholly by this
project is *also* licensed under the [ISC](https://opensource.org/licenses/ISC) license. Applicable
files will feature an ISC comment header at the top of the file to make that obvious. Keep in mind
that building and linking this source with the GPL sources causes the end product to fall under the
GPL as a whole.

## Installation

To install the project, you will need [CMake](https://cmake.org/) and a modern C compiler to build
the source tree:

```bash
git clone https://code.nephatrine.net/nephatrine/kyuii-engine.git
cd kyuii-engine
mkdir build && cd build
cmake -GNinja -DCMAKE_INSTALL_PREFIX=/path/to/install ..
ninja && ninja install
```

This will create a `${CMAKE_INSTALL_PREFIX}/kyuii` directory where the game will live.

Existing Quake II data files are not part of this project and so you will require a legal copy of
Quake II currently to utilize the project. Just copy the contents of the Quake II `baseq2` folder
into the KyuII `baseq2` folder and you should be good to go. Same for any other mod folders.

The project can generate 5 potential executables currently:

- **KyuII**: This is the standard game engine and pretty much a drop-in replacement for Quake II.
- **KyuArena**: This is a standard game engine only for hosting and joining multiplayer games only.
- **KyuDemo**: This is a standard game engine only capable of playing the singleplayer campaign.
- **KyuNode**: This is a dedicated server for hosting your own game for others to connect to.
- **KyuNet**: This is an experimental "dedicated client" that only has the ability to join games.
