# -------------------------------
# SPDX-License-Identifier: ISC
#
# Copyright © 2021 Daniel Wolf <<nephatrine@gmail.com>>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
# LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
# OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.
# -------------------------------

macro(nx_include_guard)
	get_filename_component(vIncludeGuard "${CMAKE_CURRENT_LIST_FILE}" NAME)
	string(TOUPPER "${vIncludeGuard}_INCLUDE_GUARD" vIncludeGuard)
	string(MAKE_C_IDENTIFIER "${vIncludeGuard}" vIncludeGuard)

	if(DEFINED ${vIncludeGuard})
		return()
	endif()
	if(DEFINED _NX_SCOPE)
		list(APPEND _NX_PROPAGATE_SET "${vIncludeGuard}")
	endif()
	set(${vIncludeGuard} ON)
endmacro()

macro(nx_function_guard sFunctionName)
	string(TOUPPER "${sFunctionName}_FUNCTION_GUARD" vFunctionGuard)
	string(MAKE_C_IDENTIFIER "${vFunctionGuard}" vFunctionGuard)

	if(DEFINED ${vFunctionGuard})
		return()
	endif()
	if(DEFINED _NX_SCOPE)
		list(APPEND _NX_PROPAGATE_SET "${vFunctionGuard}")
	endif()
	set(${vFunctionGuard} ON)
endmacro()
